// Greg Schaeffer
// ICFP 2001 Programming Competition
//
// File: parser.h
//
// Examine the linked list created by 
// the scanner, optimize this information,
// and create the improved structure.

#ifndef _PARSER_H_
#define _PARSER_H_
#include "lists.h"
#include "terplist.h"
#include <iostream>
#include <stdlib.h>

charnode* cursor;
terpnode* currterp;
terpnode* sp;
int tempclosed[25];

void init_currterp()
{
   currterp->tag_B = 2;
   currterp->tag_EM = 2;
   currterp->tag_I = 2;
   currterp->tag_S = 2;
   currterp->tag_TT = 2;
   currterp->tag_U = 0;
   currterp->tag_0 = 2;
   currterp->tag_1 = 2;
   currterp->tag_2 = 2;
   currterp->tag_3 = 2;
   currterp->tag_4 = 2;
   currterp->tag_5 = 2;
   currterp->tag_6 = 2;
   currterp->tag_7 = 2;
   currterp->tag_8 = 2;
   currterp->tag_9 = 2;
   currterp->tag_r = 2;
   currterp->tag_g = 2;
   currterp->tag_b = 2;
   currterp->tag_c = 2;
   currterp->tag_m = 2;
   currterp->tag_y = 2;
   currterp->tag_k = 2;
   currterp->tag_w = 2;
   currterp->tag_PL = 2;
}

void change_curr()
{
   if (cursor->tag_B != cursor->prev->tag_B) 
      currterp->tag_B = cursor->tag_B;
   if (cursor->tag_EM != cursor->prev->tag_EM) 
      currterp->tag_EM = cursor->tag_EM;
   if (cursor->tag_I != cursor->prev->tag_I) 
      currterp->tag_I = cursor->tag_I;
   if (cursor->tag_S != cursor->prev->tag_S) 
      currterp->tag_S = cursor->tag_S;
   if (cursor->tag_TT != cursor->prev->tag_TT) 
      currterp->tag_TT = cursor->tag_TT;
   if (cursor->tag_U != cursor->prev->tag_U)
      currterp->tag_U = cursor->tag_U - cursor->prev->tag_U;
   if (cursor->tag_0 != cursor->prev->tag_0) 
      currterp->tag_0 = cursor->tag_0;
   if (cursor->tag_1 != cursor->prev->tag_1) 
      currterp->tag_1 = cursor->tag_1;
   if (cursor->tag_2 != cursor->prev->tag_2) 
      currterp->tag_2 = cursor->tag_2;
   if (cursor->tag_3 != cursor->prev->tag_3) 
      currterp->tag_3 = cursor->tag_3;
   if (cursor->tag_4 != cursor->prev->tag_4) 
      currterp->tag_4 = cursor->tag_4;
   if (cursor->tag_5 != cursor->prev->tag_5) 
      currterp->tag_5 = cursor->tag_5;
   if (cursor->tag_6 != cursor->prev->tag_6) 
      currterp->tag_6 = cursor->tag_6;
   if (cursor->tag_7 != cursor->prev->tag_7) 
      currterp->tag_7 = cursor->tag_7;
   if (cursor->tag_8 != cursor->prev->tag_8) 
      currterp->tag_8 = cursor->tag_8;
   if (cursor->tag_9 != cursor->prev->tag_9) 
      currterp->tag_9 = cursor->tag_9;
   if (cursor->tag_r != cursor->prev->tag_r) 
      currterp->tag_r = cursor->tag_r;
   if (cursor->tag_g != cursor->prev->tag_g) 
      currterp->tag_g = cursor->tag_g;
   if (cursor->tag_b != cursor->prev->tag_b) 
      currterp->tag_b = cursor->tag_b;
   if (cursor->tag_c != cursor->prev->tag_c) 
      currterp->tag_c = cursor->tag_c;
   if (cursor->tag_m != cursor->prev->tag_m) 
      currterp->tag_m = cursor->tag_m;
   if (cursor->tag_y != cursor->prev->tag_y) 
      currterp->tag_y = cursor->tag_y;
   if (cursor->tag_k != cursor->prev->tag_k) 
      currterp->tag_k = cursor->tag_k;
   if (cursor->tag_w != cursor->prev->tag_w) 
      currterp->tag_w = cursor->tag_w;
   if (cursor->tag_PL != cursor->prev->tag_PL)
     currterp->tag_PL = cursor->tag_PL;
}

void redo_sp()
{
   terpnode* temp = head_terp;
   sp = temp;
   while (temp!=NULL)
   {
      if (temp->tag_B == 1 ||
          temp->tag_EM == 1 ||
          temp->tag_I == 1 ||
          temp->tag_S == 1 ||
          temp->tag_TT == 1 ||
          temp->tag_U > 0 ||
          temp->tag_0 == 1 ||
          temp->tag_1 == 1 ||
          temp->tag_2 == 1 ||
          temp->tag_3 == 1 ||
          temp->tag_4 == 1 ||
          temp->tag_5 == 1 ||
          temp->tag_6 == 1 ||
          temp->tag_7 == 1 ||
          temp->tag_8 == 1 ||
          temp->tag_9 == 1 ||
          temp->tag_r == 1 ||
          temp->tag_g == 1 ||
          temp->tag_b == 1 ||
          temp->tag_c == 1 ||
          temp->tag_m == 1 ||
          temp->tag_y == 1 ||
          temp->tag_k == 1 ||
          temp->tag_w == 1 ||
          temp->tag_PL == 1) sp = temp;

      temp = temp->next;
   }
}

void back_sp()
{
   while (sp->tag_B != 1 &&
          sp->tag_EM != 1 &&
          sp->tag_I != 1 &&
          sp->tag_S != 1 &&
          sp->tag_TT != 1 &&
          sp->tag_U <= 0 &&
          sp->tag_0 != 1 &&
          sp->tag_1 != 1 &&
          sp->tag_2 != 1 &&
          sp->tag_3 != 1 &&
          sp->tag_4 != 1 &&
          sp->tag_5 != 1 &&
          sp->tag_6 != 1 &&
          sp->tag_7 != 1 &&
          sp->tag_8 != 1 &&
          sp->tag_9 != 1 &&
          sp->tag_r != 1 &&
          sp->tag_g != 1 &&
          sp->tag_b != 1 &&
          sp->tag_c != 1 &&
          sp->tag_m != 1 &&
          sp->tag_y != 1 &&
          sp->tag_k != 1 &&
          sp->tag_w != 1 &&
          sp->tag_PL != 1 &&
          sp->prev != NULL)
      sp=sp->prev;
}

void order_tags()
{
int flag = 0;
while(!flag)
{
   flag = 1;
   if (tail_terp->tag_B == 0 && sp->tag_B == 1)
   {
      push_tag_front(sp, "+B", 1);
      sp->tag_B = 2;
      push_tag_back(tail_terp, "/B", 0);
      tail_terp->tag_B = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_EM == 0 && sp->tag_EM == 1)
   {
      push_tag_front(sp, "+E", 1);
      sp->tag_EM = 2;
      push_tag_back(tail_terp, "/E", 0);
      tail_terp->tag_EM = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_I == 0 && sp->tag_I == 1)
   {
      push_tag_front(sp, "+I", 1);
      sp->tag_I = 2;
      push_tag_back(tail_terp, "/I", 0);
      tail_terp->tag_I = 2;
      back_sp();
      flag = 0;
   }
   
   if (tail_terp->tag_S == 0 && sp->tag_S == 1)
   {
      push_tag_front(sp, "+S", 1);
      sp->tag_S = 2;
      push_tag_back(tail_terp, "/S", 0);
      tail_terp->tag_S = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_TT == 0 && sp->tag_TT == 1)
   {
      push_tag_front(sp, "+T", 1);
      sp->tag_TT = 2;
      push_tag_back(tail_terp, "/T", 0);
      tail_terp->tag_TT = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_U<0 && sp->tag_U>0)
   {
      for (int ctr=0; ctr<sp->tag_U; ctr++)
      {
         push_tag_front(sp, "+U", 1);
         sp->tag_U--;
         push_tag_back(tail_terp, "/U", 0);
         tail_terp->tag_U++;
         back_sp();
      }
      flag = 0;
   }

   if (tail_terp->tag_0 == 0 && sp->tag_0 == 1)
   {
      push_tag_front(sp, "+0", 1);
      sp->tag_0 = 2;
      push_tag_back(tail_terp, "/0", 0);
      tail_terp->tag_0 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_1 == 0 && sp->tag_1 == 1)
   {
      push_tag_front(sp, "+1", 1);
      sp->tag_1 = 2;
      push_tag_back(tail_terp, "/1", 0);
      tail_terp->tag_1 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_2 == 0 && sp->tag_2 == 1)
   {
      push_tag_front(sp, "+2", 1);
      sp->tag_2 = 2;
      push_tag_back(tail_terp, "/2", 0);
      tail_terp->tag_2 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_3 == 0 && sp->tag_3 == 1)
   {
      push_tag_front(sp, "+3", 1);
      sp->tag_3 = 2;
      push_tag_back(tail_terp, "/3", 0);
      tail_terp->tag_3 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_4 == 0 && sp->tag_4 == 1)
   {
      push_tag_front(sp, "+4", 1);
      sp->tag_4 = 2;
      push_tag_back(tail_terp, "/4", 0);
      tail_terp->tag_4 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_5 == 0 && sp->tag_5 == 1)
   {
      push_tag_front(sp, "+5", 1);
      sp->tag_5 = 2;
      push_tag_back(tail_terp, "/5", 0);
      tail_terp->tag_5 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_6 == 0 && sp->tag_6 == 1)
   {
      push_tag_front(sp, "+6", 1);
      sp->tag_6 = 2;
      push_tag_back(tail_terp, "/6", 0);
      tail_terp->tag_6 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_7 == 0 && sp->tag_7 == 1)
   {
      push_tag_front(sp, "+7", 1);
      sp->tag_7 = 2;
      push_tag_back(tail_terp, "/7", 0);
      tail_terp->tag_7 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_8 == 0 && sp->tag_8 == 1)
   {
      push_tag_front(sp, "+8", 1);
      sp->tag_8 = 2;
      push_tag_back(tail_terp, "/8", 0);
      tail_terp->tag_8 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_9 == 0 && sp->tag_9 == 1)
   {
      push_tag_front(sp, "+9", 1);
      sp->tag_9 = 2;
      push_tag_back(tail_terp, "/9", 0);
      tail_terp->tag_9 = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_r == 0 && sp->tag_r == 1)
   {
      push_tag_front(sp, "+r", 1);
      sp->tag_r = 2;
      push_tag_back(tail_terp, "/r", 0);
      tail_terp->tag_r = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_g == 0 && sp->tag_g == 1)
   {
      push_tag_front(sp, "+g", 1);
      sp->tag_g = 2;
      push_tag_back(tail_terp, "/g", 0);
      tail_terp->tag_g = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_b == 0 && sp->tag_b == 1)
   {
      push_tag_front(sp, "+b", 1);
      sp->tag_b = 2;
      push_tag_back(tail_terp, "/b", 0);
      tail_terp->tag_b = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_c == 0 && sp->tag_c == 1)
   {
      push_tag_front(sp, "+c", 1);
      sp->tag_c = 2;
      push_tag_back(tail_terp, "/c", 0);
      tail_terp->tag_c = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_m == 0 && sp->tag_m == 1)
   {
      push_tag_front(sp, "+m", 1);
      sp->tag_m = 2;
      push_tag_back(tail_terp, "/m", 0);
      tail_terp->tag_m = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_y == 0 && sp->tag_y == 1)
   {
      push_tag_front(sp, "+y", 1);
      sp->tag_y = 2;
      push_tag_back(tail_terp, "/y", 0);
      tail_terp->tag_y = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_k == 0 && sp->tag_k == 1)
   {
      push_tag_front(sp, "+k", 1);
      sp->tag_k = 2;
      push_tag_back(tail_terp, "/k", 0);
      tail_terp->tag_k = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_w == 0 && sp->tag_w == 1)
   {
      push_tag_front(sp, "+w", 1);
      sp->tag_w = 2;
      push_tag_back(tail_terp, "/w", 0);
      tail_terp->tag_w = 2;
      back_sp();
      flag = 0;
   }

   if (tail_terp->tag_PL == 0 && sp->tag_PL == 1)
   {
      push_tag_front(sp, "+P", 1);
      sp->tag_PL = 2;
      push_tag_back(tail_terp, "/P", 0);
      tail_terp->tag_PL = 2;
      back_sp();
      flag = 0;
   }
}
}

bool closing()
{
   terpnode* temp = tail_terp;
   return(temp->tag_B == 0 ||
          temp->tag_EM == 0 ||
          temp->tag_I == 0 ||
          temp->tag_S == 0 ||
          temp->tag_TT == 0 ||
          temp->tag_U < 0 ||
          temp->tag_0 == 0 ||
          temp->tag_1 == 0 ||
          temp->tag_2 == 0 ||
          temp->tag_3 == 0 ||
          temp->tag_4 == 0 ||
          temp->tag_5 == 0 ||
          temp->tag_6 == 0 ||
          temp->tag_7 == 0 ||
          temp->tag_8 == 0 ||
          temp->tag_9 == 0 ||
          temp->tag_r == 0 ||
          temp->tag_g == 0 ||
          temp->tag_b == 0 ||
          temp->tag_c == 0 ||
          temp->tag_m == 0 ||
          temp->tag_y == 0 ||
          temp->tag_k == 0 ||
          temp->tag_w == 0 ||
          temp->tag_PL == 0);
}

void close_sp()
{
   for (int ctr=0; ctr<25; ctr++) tempclosed[ctr]=0;
   if (sp->tag_B==1)
   {
      tempclosed[0] = 1;
      tail_terp->tag_B = 0;
   }
   if (sp->tag_EM==1)
   {
      tempclosed[1] = 1;
      tail_terp->tag_EM = 0;
   }
   if (sp->tag_I==1)
   {
      tempclosed[2] = 1;
      tail_terp->tag_I = 0;
   }
   if (sp->tag_S==1)
   {
      tempclosed[3] = 1;
      tail_terp->tag_S = 0;
   }
   if (sp->tag_TT==1)
   {
      tempclosed[4] = 1;
      tail_terp->tag_TT = 0;
   }
   if (sp->tag_U>0)
   {
      tempclosed[5] = sp->tag_U;
      tail_terp->tag_U = -1 * sp->tag_U;
   }
   if (sp->tag_0==1)
   {
      tempclosed[6] = 1;
      tail_terp->tag_0 = 0;
   }
   if (sp->tag_1==1)
   {
      tempclosed[7] = 1;
      tail_terp->tag_1 = 0;
   }
   if (sp->tag_2==1)
   {
      tempclosed[8] = 1;
      tail_terp->tag_2 = 0;
   }
   if (sp->tag_3==1)
   {
      tempclosed[9] = 1;
      tail_terp->tag_3 = 0;
   }
   if (sp->tag_4==1)
   {
      tempclosed[10] = 1;
      tail_terp->tag_4 = 0;
   }
   if (sp->tag_5==1)
   {
      tempclosed[11] = 1;
      tail_terp->tag_5 = 0;
   }
   if (sp->tag_6==1)
   {
      tempclosed[12] = 1;
      tail_terp->tag_6 = 0;
   }
   if (sp->tag_7==1)
   {
      tempclosed[13] = 1;
      tail_terp->tag_7 = 0;
   }
   if (sp->tag_8==1)
   {
      tempclosed[14] = 1;
      tail_terp->tag_8 = 0;
   }
   if (sp->tag_9==1)
   {
      tempclosed[15] = 1;
      tail_terp->tag_9 = 0;
   }
   if (sp->tag_r==1)
   {
      tempclosed[16] = 1;
      tail_terp->tag_r = 0;
   }
   if (sp->tag_g==1)
   {
      tempclosed[17] = 1;
      tail_terp->tag_g = 0;
   }
   if (sp->tag_b==1)
   {
      tempclosed[18] = 1;
      tail_terp->tag_b = 0;
   }
   if (sp->tag_c==1)
   {
      tempclosed[19] = 1;
      tail_terp->tag_c = 0;
   }
   if (sp->tag_m==1)
   {
      tempclosed[20] = 1;
      tail_terp->tag_m = 0;
   }
   if (sp->tag_y==1)
   {
      tempclosed[21] = 1;
      tail_terp->tag_y = 0;
   }
   if (sp->tag_k==1)
   {
      tempclosed[22] = 1;
      tail_terp->tag_k = 0;
   }
   if (sp->tag_w==1)
   {
      tempclosed[23] = 1;
      tail_terp->tag_w = 0;
   }
   if (sp->tag_PL==1)
   {
      tempclosed[24] = 1;
      tail_terp->tag_PL = 0;
   }
}

void reset_closed()
{
   if (tempclosed[0]) tail_terp->tag_B = 1;
   if (tempclosed[1]) tail_terp->tag_EM = 1;
   if (tempclosed[2]) tail_terp->tag_I = 1;
   if (tempclosed[3]) tail_terp->tag_S = 1;
   if (tempclosed[4]) tail_terp->tag_TT = 1;
   if (tempclosed[5]>0) tail_terp->tag_U = tempclosed[5];
   if (tempclosed[6]) tail_terp->tag_0 = 1;
   if (tempclosed[7]) tail_terp->tag_1 = 1;
   if (tempclosed[8]) tail_terp->tag_2 = 1;
   if (tempclosed[9]) tail_terp->tag_3 = 1;
   if (tempclosed[10]) tail_terp->tag_4 = 1;
   if (tempclosed[11]) tail_terp->tag_5 = 1;
   if (tempclosed[12]) tail_terp->tag_6 = 1;
   if (tempclosed[13]) tail_terp->tag_7 = 1;
   if (tempclosed[14]) tail_terp->tag_8 = 1;
   if (tempclosed[15]) tail_terp->tag_9 = 1;
   if (tempclosed[16]) tail_terp->tag_r = 1;
   if (tempclosed[17]) tail_terp->tag_g = 1;
   if (tempclosed[18]) tail_terp->tag_b = 1;
   if (tempclosed[19]) tail_terp->tag_c = 1;
   if (tempclosed[20]) tail_terp->tag_m = 1;
   if (tempclosed[21]) tail_terp->tag_y = 1;
   if (tempclosed[22]) tail_terp->tag_k = 1;
   if (tempclosed[23]) tail_terp->tag_w = 1;
   if (tempclosed[24]) tail_terp->tag_PL = 1;
}

void parseit()
{
   currterp = new(terpnode);
   sp = NULL;
   if (char_head->next != NULL)
   {
      cursor=char_head->next;
      while (cursor!=NULL)
      {
         init_currterp();
         if (cursor->prev_diff)
         {
            change_curr();
            push_terp(currterp);
            if (sp==NULL) sp = head_terp;
            if (closing()) order_tags();

            while (closing())
            {
               close_sp();
               order_tags();
               reset_closed();
               back_sp();
            }

            redo_sp();
            push_text(tail_terp, cursor->text);
         }
         else
         {
            if (head_terp==NULL) push_terp(currterp);
            push_text(tail_terp, cursor->text);
         }
         if (cursor->next!=NULL)
            cursor=cursor->next;
         else
            cursor=NULL;
      }
   }
}

#endif