// Greg Schaeffer
// ICFP 2001 Programming Contest
//
// File: scanner.h
//
// Reads in SML/NG input and creates linked list
// of contexts and characters.

#ifndef _SCANNER_H_
#define _SCANNER_H_
#include <iostream>
#include <stdlib.h>
#include "lists.h"

contextnode* current = new(contextnode);
char c;

void init_current()
{
   current -> next = NULL;
   current -> tag_B = 0;
   current -> tag_EM = 0;
   current -> tag_I = 0;
   current -> tag_S = 0;
   current -> tag_TT = 0;
   current -> tag_U = 0;
   current -> tag_0 = 0;
   current -> tag_1 = 0;
   current -> tag_2 = 0;
   current -> tag_3 = 0;
   current -> tag_4 = 0;
   current -> tag_5 = 0;
   current -> tag_6 = 0;
   current -> tag_7 = 0;
   current -> tag_8 = 0;
   current -> tag_9 = 0;
   current -> tag_r = 0;
   current -> tag_g = 0;
   current -> tag_b = 0;
   current -> tag_c = 0;
   current -> tag_m = 0;
   current -> tag_y = 0;
   current -> tag_k = 0;
   current -> tag_w = 0;
}

void test_crap()
{
   charnode* temp = char_head;
   cout<<"BEISTUP 0123456789 rgbcmykw text diff\n";
   while (temp!=NULL)
   {
      cout<<temp->tag_B<<temp->tag_EM<<temp->tag_I<<temp->tag_S
          <<temp->tag_TT<<temp->tag_U<<temp->tag_PL<<" "
          <<temp->tag_0<<temp->tag_1<<temp->tag_2<<temp->tag_3<<temp->tag_4
          <<temp->tag_5<<temp->tag_6<<temp->tag_7<<temp->tag_8<<temp->tag_9<<" "
          <<temp->tag_r<<temp->tag_g<<temp->tag_b<<temp->tag_c<<temp->tag_m
          <<temp->tag_y<<temp->tag_k<<temp->tag_w<<" "
          <<temp->text<<"    "<<temp->prev_diff<<endl;
      temp=temp->next;
   }
}

int numch(charnode* x)
{
   int num = 0;
   if (x->tag_B != x->prev->tag_B) num++;
   if (x->tag_I != x->prev->tag_I) num++;
   if (x->tag_EM != x->prev->tag_EM) num++;
   if (x->tag_TT != x->prev->tag_TT) num++;
   if (x->tag_S != x->prev->tag_S) num++;
   if (x->tag_U != x->prev->tag_U) num++;
   return num;
}

void PL_check()
{
   charnode* temp = char_head;
   charnode* temp2;

   while(temp!=NULL)
   {
      temp->tag_PL = 0;
      temp=temp->next;
   }

   if (char_head->next != NULL)
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_B == 0 && temp->tag_EM == 0 &&
             temp->tag_I == 0 && temp->tag_TT == 0 &&
             temp->tag_U == 0 && temp->tag_S == 0 && numch(temp) > 1)
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_B == 1 || temp2->tag_EM == 1 ||
                   temp2->tag_I == 1 || temp2->tag_TT == 1 ||
                   temp2->tag_U == 1 || temp2->tag_S == 1)
               {
                  while (temp != temp2)
                  {
                     temp->tag_B = temp->prev->tag_B;
                     temp->tag_I = temp->prev->tag_I;
                     temp->tag_U = temp->prev->tag_U;
                     temp->tag_EM = temp->prev->tag_EM;
                     temp->tag_TT = temp->prev->tag_TT;
                     temp->tag_S = temp->prev->tag_S;
                     temp->tag_PL = 1;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }
}

bool rise(charnode* x)
{
   return ((x->tag_r==1 && x->prev->tag_r==0) ||
           (x->tag_g==1 && x->prev->tag_g==0) ||
           (x->tag_b==1 && x->prev->tag_b==0) ||
           (x->tag_c==1 && x->prev->tag_c==0) ||
           (x->tag_m==1 && x->prev->tag_m==0) ||
           (x->tag_y==1 && x->prev->tag_y==0) ||
           (x->tag_k==1 && x->prev->tag_k==0) ||
           (x->tag_w==1 && x->prev->tag_w==0)); 
}

bool fall(charnode* x)
{
   return ((x->tag_r==0 && x->prev->tag_r==1) ||
           (x->tag_g==0 && x->prev->tag_g==1) ||
           (x->tag_b==0 && x->prev->tag_b==1) ||
           (x->tag_c==0 && x->prev->tag_c==1) ||
           (x->tag_m==0 && x->prev->tag_m==1) ||
           (x->tag_y==0 && x->prev->tag_y==1) ||
           (x->tag_k==0 && x->prev->tag_k==1) ||
           (x->tag_w==0 && x->prev->tag_w==1));
}

void color_check(char p)
{
   charnode* temp = char_head;
   charnode* temp2;

   if (p=='-') return;

   if (char_head->next != NULL && p=='0')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_r == 0 && temp->prev->tag_r == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_r == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_r = temp->prev->tag_r;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '1')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_g == 0 && temp->prev->tag_g == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_g == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_g = temp->prev->tag_g;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '2')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_b == 0 && temp->prev->tag_b == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_b == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_b = temp->prev->tag_b;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '3')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_c == 0 && temp->prev->tag_c == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_c == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_c = temp->prev->tag_c;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '4')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_m == 0 && temp->prev->tag_m == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_m == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_m = temp->prev->tag_m;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '5')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_y == 0 && temp->prev->tag_y == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_y == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_y = temp->prev->tag_y;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '6')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_k == 0 && temp->prev->tag_k == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_k == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_k = temp->prev->tag_k;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL && p == '7')
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_w == 0 && temp->prev->tag_w == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_w == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp->tag_w = temp->prev->tag_w;
                     temp = temp->next;
                  }
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

}

char color_best()
{
   charnode* temp = char_head;
   charnode* temp2;

   int numnest[8] = {0,0,0,0,0,0,0,0};
   int high = 0;

   if (char_head->next != NULL)   //iterate through r
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_r == 0 && temp->prev->tag_r == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_r == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[0]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through g
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_g == 0 && temp->prev->tag_g == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_g == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[1]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through b
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_b == 0 && temp->prev->tag_b == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_b == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[2]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through c
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_c == 0 && temp->prev->tag_c == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_c == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[3]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through m
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_m == 0 && temp->prev->tag_m == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_m == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[4]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)  //iterate through y
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_y == 0 && temp->prev->tag_y == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_y == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[5]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through k
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_k == 0 && temp->prev->tag_k == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_k == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[6]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   if (char_head->next != NULL)   //iterate through w
   {
      temp=char_head -> next;
      while (temp->next != char_tail && temp != char_tail)
      {
         if (temp->tag_w == 0 && temp->prev->tag_w == 1 && rise(temp))
         {
            temp2=temp;
            while (temp2->next != char_tail)
            {
               if (temp2->tag_w == 1 && fall(temp2))
               {
                  while (temp != temp2)
                  {
                     temp = temp->next;
                  }
                  numnest[7]++;
                  break;
               }
               temp2 = temp2->next;
            }
         }
         temp=temp->next;
      }
   }

   int ctr;
   for (ctr=0; ctr<8; ctr++)
      if (numnest[ctr]>high) high=numnest[ctr];

   if (high==0) return '-';

   for (ctr=0; ctr<8; ctr++)
      if (numnest[ctr]==high) return ('0' + ctr);

   return '-';
}

void getlist()
{
   init_current();
   init_charnode(current);
   char result;

   while (!cin.eof())
   {
      c = cin.get();
      if (cin.eof()) break;
      if (c=='<')
      {
         c = cin.get();
         if (c=='/')
         {
            pop_context(current);
            while (c!='>') c=cin.get();
         }
         else
         {
            push_context(current);
            switch(c)
            {
            case 'B':
               current -> tag_B = 1;
               c = cin.get();
               break;
            case 'E':
               if (!current->tag_S) current->tag_EM = !(current->tag_EM);
               c = cin.get();
               c = cin.get();
               break;
            case 'I':
               current -> tag_I = 1;
               c = cin.get();
               break;
            case 'P':
               current -> tag_B = 0;
               current -> tag_EM = 0;
               current -> tag_I = 0;
               current -> tag_S = 0;
               current -> tag_TT = 0;
               current -> tag_U = 0;
               c = cin.get();
               c = cin.get();
               break;
            case 'S':
               current -> tag_S = 1;
               current -> tag_EM = 0;
               c = cin.get();
               break;
            case 'T':
               current -> tag_TT = 1;
               c = cin.get();
               c = cin.get();
               break;
            case 'U':
               if (current->tag_U<3) current -> tag_U++;
               c = cin.get();
               break;
            case 'r':
               current -> tag_r = 1;
               c = cin.get();
               break;
            case 'g':
               current -> tag_g = 1;
               c = cin.get();
               break;
            case 'b':
               current -> tag_b = 1;
               c = cin.get();
               break;
            case 'c':
               current -> tag_c = 1;
               c = cin.get();
               break;
            case 'm':
               current -> tag_m = 1;
               c = cin.get();
               break;
            case 'y':
               current -> tag_y = 1;
               c = cin.get();
               break;
            case 'k':
               current -> tag_k = 1;
               c = cin.get();
               break;
            case 'w':
               current -> tag_w = 1;
               c = cin.get();
               break;
            case '0':
               current -> tag_0 = 1;
               c = cin.get();
               break;
            case '1':
               current -> tag_1 = 1;
               c = cin.get();
               break;
            case '2':
               current -> tag_2 = 1;
               c = cin.get();
               break;
            case '3':
               current -> tag_3 = 1;
               c = cin.get();
               break;
            case '4':
               current -> tag_4 = 1;
               c = cin.get();
               break;
            case '5':
               current -> tag_5 = 1;
               c = cin.get();
               break;
            case '6':
               current -> tag_6 = 1;
               c = cin.get();
               break;
            case '7':
               current -> tag_7 = 1;
               c = cin.get();
               break;
            case '8':
               current -> tag_8 = 1;
               c = cin.get();
               break;
            case '9':
               current -> tag_9 = 1;
               c = cin.get();
               break;
            }
         }
      }
      else
      {
         push_charnode(current, c);
      }
   }

   init_current();
   push_charnode(current,'>');
   while (context_head!=NULL) pop_context(current);
   PL_check();

//   for (int lcv=0; lcv<8; lcv++)
//   {
      result=color_best();
//      if (result=='-') break;
      color_check(result);
//   }

   //test_crap();
}
#endif